/*-----------------------------------------------------------------------
 * FUNCTION:   read_data
 *
 * PURPOSE:   reads  "size" 16-bit speech samples from the file "fp" and
 *            output to the array "data[]"
 *
 *-------------------------------------------------------------------------*/

#include <stdio.h>
#include "amr_plus_fx.h"
#include "typedef.h"
#include "basic_op.h"
#include "count.h"

Word16 Read_data(      /* return: number of data successfully read */
  FILE  *fp,        /* input : data file (16-bit words)         */
  Word16 data[],     /* output: speech data                      */
  Word16 size        /* input : number of samples                */
)
{
  Word16 i, n;
  Word16 data16[4*L_FRAME_FSMAX];

  n = (Word16)fread((void *)data16, sizeof(short), size, fp);

  for (i = 0; i < n; i++)  
  {
    data[i] = data16[i];    move16();
  }

  for (i = n; i < size; i++)  
  {
    data[i] = 0;      move16();
  }

  return n;
}
