#include "amr_plus_fx.h"

#include "typedef.h"
#include "basic_op.h"
#include "oper_32b.h"
#include "count.h"



/* local function */
static Word16 Pack4bits(Word16 nbits, Word16 *ptr, Word16 *prm);


void Dec_prm(
  Word16 mod[],         /* (i) : frame mode (mode[4], 4 frames)   */
  Word16 bad_frame[],   /* (i) : bfi for 4 frames (bad_frame[4])  */
  Word16 serial[],      /* (i) : serial bits stream               */
  Word16 nbits_pack,    /* (i) : number of bits per packet of 20ms*/
  Word16 codec_mode,    /* (i) : AMR-WB+ mode (see cnst.h)        */
  Word16 param[],       /* (o) : decoded parameters               */
  Word16 nbits_AVQ[]    /* (o) : nb of bits for AVQ (4 division)  */
)                       
{
  Word16 j, k, mode, nbits, n, sfr, index0, index1, parity, n_loss, i;
  Word16 *ptr, *prm;
  /* remove bits for mode and HF extension */
  nbits = sub(shr(NBITS_CORE_FX[codec_mode],2),2);

  k = 0;    move16();
  
  test();
  while (sub(k,NB_DIV) < 0)
  {
    test();
    mode = mod[k];      move16();
    prm = param + (k*DEC_NPRM_DIV);

    test();test();test();test();
    if ((mode == 0) || (sub(mode,1) == 0))
    {
      ptr = serial + shr(extract_l(L_mac(4, k, nbits_pack)),1); /* +2 because of mode */ 

      prm[0] = Bin2int(8, ptr);      ptr += 8;  move16();
      prm[1] = Bin2int(8, ptr);      ptr += 8;  move16();
      prm[2] = Bin2int(6, ptr);      ptr += 6;  move16();
      prm[3] = Bin2int(7, ptr);      ptr += 7;  move16();
      prm[4] = Bin2int(7, ptr);      ptr += 7;  move16();
      prm[5] = Bin2int(5, ptr);      ptr += 5;  move16();
      prm[6] = Bin2int(5, ptr);      ptr += 5;  move16();

      test();
      if (mode == 0)
      {
        j = 7;   move16();
        prm[j] = Bin2int(2, ptr);   ptr += 2;   j++;    move16();

        for (sfr=0; sfr<4; sfr++)
        {
          test();test();
          if ((sfr==0) || (sub(sfr,2)==0)) 
          {
            n=9;      move16();
          }
          else 
          {
            n=6;      move16();
          }

          prm[j] = Bin2int(n, ptr);       ptr += n;    j++;  move16(); 
          prm[j] = Bin2int(1, ptr);       ptr += 1;    j++;  move16();

          test();test();test();test();test();test();
          if (sub(codec_mode,MODE_9k6) == 0)
          {
            /* 20 bits AMR-WB codebook is used */
            prm[j] = Bin2int(5, ptr);       ptr += 5;     j++;  move16();
            prm[j] = Bin2int(5, ptr);       ptr += 5;     j++;  move16();
            prm[j] = Bin2int(5, ptr);       ptr += 5;     j++;  move16();
            prm[j] = Bin2int(5, ptr);       ptr += 5;     j++;  move16();
          }
          else if (sub(codec_mode,MODE_11k2) == 0)
          {
            /* 28 bits AMR-WB codebook is used */
            prm[j] = Bin2int(9, ptr);       ptr += 9;     j++;  move16();
            prm[j] = Bin2int(9, ptr);       ptr += 9;     j++;  move16();
            prm[j] = Bin2int(5, ptr);       ptr += 5;     j++;  move16();
            prm[j] = Bin2int(5, ptr);       ptr += 5;     j++;  move16();
          }
          else if (sub(codec_mode,MODE_12k8) == 0)
          {
            /* 36 bits AMR-WB codebook is used */
            prm[j] = Bin2int(9, ptr);       ptr += 9;     j++;  move16();
            prm[j] = Bin2int(9, ptr);       ptr += 9;     j++;  move16();
            prm[j] = Bin2int(9, ptr);       ptr += 9;     j++;  move16();
            prm[j] = Bin2int(9, ptr);       ptr += 9;     j++;  move16();
          }
          else if (sub(codec_mode,MODE_14k4) == 0)
          {
            /* 44 bits AMR-WB codebook is used */
            prm[j] = Bin2int(13, ptr);      ptr += 13;    j++;  move16();
            prm[j] = Bin2int(13, ptr);      ptr += 13;    j++;  move16();
            prm[j] = Bin2int(9, ptr);       ptr += 9;     j++;  move16();
            prm[j] = Bin2int(9, ptr);       ptr += 9;     j++;  move16();
          }
          else if (sub(codec_mode,MODE_16k) == 0)
          {
            /* 52 bits AMR-WB codebook is used */
            prm[j] = Bin2int(13, ptr);      ptr += 13;    j++;  move16();
            prm[j] = Bin2int(13, ptr);      ptr += 13;    j++;  move16();
            prm[j] = Bin2int(13, ptr);      ptr += 13;    j++;  move16();
            prm[j] = Bin2int(13, ptr);      ptr += 13;    j++;  move16();
          }
          else if (sub(codec_mode,MODE_18k4) == 0)
          { 
            /* 64 bits AMR-WB codebook is used */
            prm[j] = Bin2int(2, ptr);       ptr += 2;     j++;  move16();
            prm[j] = Bin2int(2, ptr);       ptr += 2;     j++;  move16();
            prm[j] = Bin2int(2, ptr);       ptr += 2;     j++;  move16();
            prm[j] = Bin2int(2, ptr);       ptr += 2;     j++;  move16();
            prm[j] = Bin2int(14, ptr);      ptr += 14;    j++;  move16();
            prm[j] = Bin2int(14, ptr);      ptr += 14;    j++;  move16();
            prm[j] = Bin2int(14, ptr);      ptr += 14;    j++;  move16();
            prm[j] = Bin2int(14, ptr);      ptr += 14;    j++;  move16();
          }
          else if (sub(codec_mode,MODE_20k) == 0)
          {
            /* 72 bits AMR-WB codebook is used */
            prm[j] = Bin2int(10, ptr);      ptr += 10;    j++;  move16();
            prm[j] = Bin2int(10, ptr);      ptr += 10;    j++;  move16();
            prm[j] = Bin2int(2,  ptr);      ptr += 2;     j++;  move16();
            prm[j] = Bin2int(2,  ptr);      ptr += 2;     j++;  move16();
            prm[j] = Bin2int(10, ptr);      ptr += 10;    j++;  move16();
            prm[j] = Bin2int(10, ptr);      ptr += 10;    j++;  move16();
            prm[j] = Bin2int(14, ptr);      ptr += 14;    j++;  move16();
            prm[j] = Bin2int(14, ptr);      ptr += 14;    j++;  move16();
          }
          else if (sub(codec_mode,MODE_23k2) == 0)
          {
            /* 88 bits AMR-WB codebook is used */
            prm[j] = Bin2int(11, ptr);      ptr += 11;    j++;  move16();
            prm[j] = Bin2int(11, ptr);      ptr += 11;    j++;  move16();
            prm[j] = Bin2int(11, ptr);      ptr += 11;    j++;  move16();
            prm[j] = Bin2int(11, ptr);      ptr += 11;    j++;  move16();
            prm[j] = Bin2int(11, ptr);      ptr += 11;    j++;  move16();
            prm[j] = Bin2int(11, ptr);      ptr += 11;    j++;  move16();
            prm[j] = Bin2int(11, ptr);      ptr += 11;    j++;  move16();
            prm[j] = Bin2int(11, ptr);      ptr += 11;    j++;  move16();
          }

          prm[j] = Bin2int(7, ptr);       ptr += 7;    j++;  move16();  
        }
      }
      else  /* mode 1 */
      {
        prm[7] = Bin2int(3, ptr);     ptr += 3;   move16();
        prm[8] = Bin2int(7, ptr);     ptr += 7;   move16();

        nbits_AVQ[k] = sub(nbits,56);         move16();
        Pack4bits(nbits_AVQ[k], ptr, prm+9);
      }
      k++;
    }
    else if (sub(mode,2) == 0)
    {
      /* decode first 20ms packet */
      ptr = serial + shr(extract_l(L_mac(4, k, nbits_pack)),1);

      prm[0] = Bin2int(8, ptr);    ptr += 8;  move16();
      prm[1] = Bin2int(8, ptr);    ptr += 8;  move16();
      prm[7] = Bin2int(3, ptr);    ptr += 3;  move16();
      prm[8] = Bin2int(7, ptr);    ptr += 7;  move16();


      nbits_AVQ[k] = sub(nbits, 26);            move16();
      j = 9;                              move16();
      j = add(j,Pack4bits(nbits_AVQ[k], ptr, prm+j));
      k++;

      /* decode second 20ms packet */
      ptr = serial + shr(extract_l(L_mac(4, k,nbits_pack)),1);

      prm[2] = Bin2int(6, ptr);    ptr += 6;  move16();
      prm[3] = Bin2int(7, ptr);    ptr += 7;  move16();
      prm[4] = Bin2int(7, ptr);    ptr += 7;  move16();
      prm[5] = Bin2int(5, ptr);    ptr += 5;  move16();
      prm[6] = Bin2int(5, ptr);    ptr += 5;  move16();
      test();
      if (sub(bad_frame[k-1],1)==0) 
      {
        prm[8] = shl(Bin2int(6, ptr),1);      move16();
      }
      ptr += 6;

      nbits_AVQ[k] = sub(nbits,30+6);       move16();/* 6 bits of redundancy for TCX gain */ 
      Pack4bits(nbits_AVQ[k], ptr, prm+j);
      k++;
    }
    else if (sub(mode,3) == 0)
    {
      /* decode first 20ms packet */
      ptr = serial + shr(extract_l(L_mac(4, k, nbits_pack)),1);

      prm[0] = Bin2int(8, ptr);    ptr += 8;  move16();
      prm[1] = Bin2int(8, ptr);    ptr += 8;  move16();
      prm[8] = Bin2int(7, ptr);    ptr += 7;  move16();

      nbits_AVQ[k] = sub(nbits, 23);  move16();
      j = 9;  move16();
      j = add(j, Pack4bits(nbits_AVQ[k], ptr, prm+j));
      k++;

      /* decode second 20ms packet */
      ptr = serial + shr(extract_l(L_mac(4, k, nbits_pack)),1);

      prm[2] = Bin2int(6, ptr);    ptr += 6;  move16();
      prm[7] = Bin2int(3, ptr);    ptr += 3;  move16();

      /* read parity check bits */
      parity = Bin2int(3, ptr);    ptr += 3;

      nbits_AVQ[k] = sub(nbits, 9+3);  move16();
      j = add(j, Pack4bits(nbits_AVQ[k], ptr, prm+j));
      k++;

      /* decode third 20ms packet */
      ptr = serial + shr(extract_l(L_mac(4, k, nbits_pack)),1);

      prm[3] = Bin2int(7, ptr);    ptr += 7;  move16();
      prm[5] = Bin2int(5, ptr);    ptr += 5;  move16();

      /* read parity check bits */
      index0 = Bin2int(3, ptr);  ptr += 3;

      nbits_AVQ[k] = sub(nbits, 12+3);  move16();
      j = add(j, Pack4bits(nbits_AVQ[k], ptr, prm+j));
      k++;

      /* decode fourth 20ms packet */
      ptr = serial + shr(extract_l(L_mac(4, k, nbits_pack)),1);

      prm[4] = Bin2int(7, ptr);    ptr += 7;  move16();
      prm[6] = Bin2int(5, ptr);    ptr += 5;  move16();

      /* read parity check bits */
      index1 = Bin2int(3, ptr);    ptr += 3;

      /* use the redundancy bits to recover the index of TCX gain in case of packet erasures */
      n_loss = 0;  move16();
      
      for (i=1; i<4; i++) 
      {
        n_loss = add(n_loss, bad_frame[i]);
      }
      test();test();
      if ((sub(bad_frame[0],1)==0) && (sub(n_loss,1) <= 0)) 
      {
        /* decode the index of TCX gain */
        test();
        if (sub(bad_frame[2],1) == 0) 
        {
          index0 = (parity^index1);       logic16();
        }
        test();
        if (sub(bad_frame[3],1) == 0) 
        {
          index1 = (parity^index0);       logic16();
        }

        prm[8] = add(shl(index0,4) , shl(index1,1));  move16();
      }

      nbits_AVQ[k] = sub(nbits, 12+3);  move16();
      Pack4bits(nbits_AVQ[k], ptr, prm+j);
      k++;
    }    /*mode 3*/
  }      /* end while (k < NB_DIV) */
  return;
}



void Dec_prm_hf(
  Word16 mod[],         /* (i) : frame mode (mode[4], 4 frames)   */
  Word16 bad_frame[],   /* (i) : bfi for 4 frames (bad_frame[4])  */
  Word16 serial[],      /* (i) : serial bits stream               */
  Word16 nbits_pack,    /* (i) : number of bits per packet of 20ms*/
  Word16 param[]        /* (o) : decoded parameters               */
)                       
{
  Word16 i, k, mode, nbits, *prm;
  Word16 *ptr;
  /* number of bits for HF extension (per packet of 20 ms) */
  nbits = NBITS_BWE/4;        move16();

  k = 0;                      move16();
  test();
  while (sub(k,NB_DIV) < 0)
  {
    test();  
    mode = mod[k];            move16();

    /* set pointer to parameters */
    prm = param + shr(extract_l(L_mult(k, NPRM_BWE_DIV)),1);

    /* decode first 20ms packet */
    ptr = serial + sub(shr(extract_l(L_mult(add(k,1),nbits_pack)),1), nbits);

    prm[0] = Bin2int(2, ptr);      ptr += 2;      move16();
    prm[1] = Bin2int(7, ptr);      ptr += 7;      move16();
    prm[2] = Bin2int(7, ptr);      ptr += 7;      move16();
    k++;

    test();test();
    if (sub(mode,2) == 0)
    {
      /* decode second 20ms packet */
      ptr = serial + sub(shr(extract_l(L_mult(add(k,1),nbits_pack)),1), nbits);


      for (i=3; i<=10; i++) 
      {
        prm[i] = Bin2int(2, ptr);    ptr += 2;      move16();
      }
      k++;
    }
    else if (sub(mode,3) == 0)
    {
      /* decode second 20ms packet */
      ptr = serial + sub(shr(extract_l(L_mult(add(k,1),nbits_pack)),1), nbits);


      for (i=3; i<=10; i++) 
      {
        prm[i] = shl(Bin2int(2, ptr),1);   ptr += 2;      move16();
      }
      k++;

      /* decode third 20ms packet */
      ptr = serial + sub(shr(extract_l(L_mult(add(k,1),nbits_pack)),1), nbits);


      for (i=11; i<=18; i++) 
      {
        prm[i] = shl(Bin2int(2, ptr),1);   ptr += 2;    move16();
      }
      k++;

      /* decode fourth 20ms packet */
      ptr = serial + sub(shr(extract_l(L_mult(add(k,1),nbits_pack)),1), nbits);
      test();  
      if (bad_frame[k] == 0)
      {

        for (i=3; i<=18; i++) 
        {
          prm[i] = add(prm[i],  Bin2int(1, ptr));     ptr += 1;      move16();
        }
      }
      k++;
    }
  }  /* end while (k < NB_DIV) */
  return;
}



static Word16 Pack4bits(
  Word16  nbits,
  Word16 *ptr,
  Word16 *prm
)
{
  Word16 i;

  i=0;      move16();
  test();  
  while (sub(nbits,4) > 0)
  {
    prm[i] = Bin2int(4, ptr);   move16();
    ptr += 4;
    nbits = sub(nbits, 4);
    i++;
  }
  prm[i] = Bin2int(nbits, ptr);     move16();
  i++;

  return(i);
}

